#Track Setup Database
##########################################
db.define_table('t_trackSetup',
    Field('f_trackType', type='list:string', requires=IS_IN_SET(("Straight", "Curve", "Crossing", "Number of loadings")), default="Straight",
          label=T('Type of Track Part'), comment=""),
    Field('f_distance', type='float', default = 0,
          label=T('Distance of Track Part'), comment="m"),
    Field('f_timestopped', type='float', default = 0,
          label=T('Time spend stopped'), comment="m"),
    Field('f_amount', type='float', default = 1,
          label=T('Amount'), comment=""),
    format='%(f_trackType)s',
    migrate=settings.migrate)

############################################

db.define_table('t_bliskData',
    Field('f_width', type='float', default=45,
          label=T('Width'), comment="mm"),
    Field('f_length', type='float', default=45,
          label=T('Length'), comment="mm"),
    Field('f_height', type='float', default=100,
          label=T('Height'), comment="mm"),
    Field('f_number', type='float', default=30,
          label=T('Number of Blades per BLISK'), comment="n°"),
    format='%(f_width)s',
    migrate=settings.migrate)

############################################
#Table for Roughing Task
db.define_table('t_blisktasks_roughing',
    Field('f_surface_thickness', type='float', default = 10,
          label=T('Surface Thickness'), comment="mm"),
    Field('f_millingvolume', type='float', default = 0,
          label=T('Milling Volume per BLISK'), comment="mm^3"),
    Field('f_radialcuttingdepth', type='float', default = 2,
          label=T('Radial Cutting Depth'), comment="mm"),
    Field('f_axialcuttingdepth', type='float', default = 7.5,
          label=T('Axial Cutting Depth'), comment="mm"),
    Field('f_feedspeed_nofiveG', type='float', default = 1200,
          label=T('Feed Speed - Without 5G'), comment="mm/min"),
    Field('f_feedspeed_fiveG', type='float', default = 1250,
          label=T('Feed Speed - With 5G - Expected'), comment="mm/min"),
    Field('f_mrr_nofiveG', type='float',
          label=T('MRR - Without 5G'), comment="mm^3/min"),
    Field('f_mrr_fiveG', type='float',
          label=T('MRR - With 5G'), comment="mm^3/min"),
    Field('f_millingtime', type='float',
          label=T('Milling Time'), comment="min"),
    Field('f_vibrations_shattering', type='float', default = 0,
          label=T('Vibrations per Minute causing shattering marks'), comment=" n°"),
    Field('f_tooldamage', type='float', default = 0.0001,
          label=T('Tool Damages per Minute'), comment=" n°"),
    Field('f_tooldamage_weighted', type='float', default = 0,
          label=T('Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_tooldamage_critical', type='float', default = 0.00001,
          label=T('Critical Tool Damages per Minute'), comment=" n°"),
    Field('f_tooldamage_critical_weighted', type='float', default = 0,
          label=T('Critical Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_vibrations_blisk', type='float', default = 0,
          label=T('Vibrations per BLISK'), comment=" n°"),
    Field('f_vibrations_blisk_noreaction', type='float', default = 0,
          label=T('Vibrations per BLISK with 5G without reaction'), comment=" n°"),
    Field('f_feedspeedadoption_number', type='float', default = 0,
          label=T('Times of Feed Speed Adoption'), comment=" n°"),
    Field('f_additionaltime_vibration', type='float', default = 0,
          label=T('Additional Processing Time through Feed Speed Adoption per Vibration'), comment=" s"),
    Field('f_additionaltime_total', type='float', default = 0,
          label=T('Additional Processing Time through Feed Speed Adoption'), comment=" s"),
    Field('f_damage_blisk', type='float', default = 0,
          label=T('Damage per BLISK'), comment=" "),
    format='%(f_millingtype)s',
    migrate=settings.migrate)

############################################
#Table for Pre Finishing Task
db.define_table('t_blisktasks_prefinish',
    Field('f_surface_thickness', type='float', default = 5,
          label=T('Surface Thickness'), comment="mm"),
    Field('f_millingvolume', type='float', default = 0,
          label=T('Milling Volume per BLISK'), comment="mm^3"),
    Field('f_radialcuttingdepth', type='float', default = 2,
          label=T('Radial Cutting Depth'), comment="mm"),
    Field('f_axialcuttingdepth', type='float', default = 5,
          label=T('Axial Cutting Depth'), comment="mm"),
    Field('f_feedspeed_nofiveG', type='float', default = 730,
          label=T('Feed Speed - Without 5G'), comment="mm/min"),
    Field('f_feedspeed_fiveG', type='float', default = 750,
          label=T('Feed Speed - With 5G - Expected'), comment="mm/min"),
    Field('f_mrr_nofiveG', type='float',
          label=T('MRR - Without 5G'), comment="mm^3/min"),
    Field('f_mrr_fiveG', type='float',
          label=T('MRR - With 5G'), comment="mm^3/min"),
    Field('f_millingtime', type='float',
          label=T('Milling Time'), comment="min"),
    Field('f_vibrations_shattering', type='float', default = 0.01,
          label=T('Vibrations per Minute causing shattering marks'), comment=" n°"),
    Field('f_vibrations_nonreparable', type='float', default = 0,
          label=T('Vibrations per Minute causing non reparable BLISK damage'), comment=" n°"),
    Field('f_tooldamage', type='float', default = 0.0001,
          label=T('Tool Damages per Minute'), comment=" n°"),
    Field('f_tooldamage_weighted', type='float', default = 0,
          label=T('Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_tooldamage_critical', type='float', default = 0.00001,
          label=T('Critical Tool Damages per Minute'), comment=" n°"),
    Field('f_tooldamage_critical_weighted', type='float', default = 0,
          label=T('Critical Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_vibrations_blisk', type='float', default = 0,
          label=T('Vibrations per BLISK'), comment=" number/BLISK"),
    Field('f_vibrations_blisk_noreaction', type='float', default = 0,
          label=T('Vibrations per BLISK - with 5G without reaction '), comment=" n°"),
    Field('f_feedspeedadoption_number', type='float', default = 0,
          label=T('Times of Feed Speed Adoption'), comment=" n°"),
    Field('f_additionaltime_vibration', type='float', default = 0.25,
          label=T('Additional Processing Time through Feed Speed Adoption per Vibration'), comment=" s"),
    Field('f_additionaltime_total', type='float', default = 0,
          label=T('Additional Processing Time through Feed Speed Adoption'), comment=" s"),
    Field('f_damage_blisk', type='float', default = 0,
          label=T('Damage per BLISK'), comment=" "),
    format='%(f_millingtype)s',
    migrate=settings.migrate)

############################################
#Table for Blade Finishing Task
db.define_table('t_blisktasks_bladefinish',
    Field('f_surface_thickness', type='float', default = 0.011,
          label=T('Surface Thickness'), comment="mm"),
    Field('f_millingvolume', type='float', default = 0,
          label=T('Milling Volume per BLISK'), comment="mm^3"),
    Field('f_radialcuttingdepth', type='float', default = 0.5,
          label=T('Radial Cutting Depth'), comment="mm"),
    Field('f_axialcuttingdepth', type='float', default = 0.6,
          label=T('Axial Cutting Depth'), comment="mm"),
    Field('f_feedspeed_nofiveG', type='float', default = 350,
          label=T('Feed Speed - Without 5G'), comment="mm/min"),
    Field('f_feedspeed_fiveG', type='float', default = 360,
          label=T('Feed Speed - With 5G - Expected'), comment="mm/min"),
    Field('f_mrr_nofiveG', type='float',
          label=T('MRR - Without 5G'), comment="mm^3/min"),
    Field('f_mrr_fiveG', type='float',
          label=T('MRR - With 5G'), comment="mm^3/min"),
    Field('f_millingtime', type='float',
          label=T('Milling Time'), comment="min"),
    Field('f_vibrations_shattering', type='float', default = 0.2,
          label=T('Vibrations per Minute causing shattering marks'), comment=" n°"),
    Field('f_vibrations_nonreparable', type='float', default = 0.0001,
          label=T('Vibrations per Minute causing non reparable BLISK damage'), comment=" n°"),
    Field('f_tooldamage', type='float', default = 0.00001,
          label=T('Tool Damages per Minute'), comment=" n°"),
    Field('f_tooldamage_weighted', type='float', default = 0,
          label=T('Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_tooldamage_critical', type='float', default = 0.00001,
          label=T('Critical Tool Damages per Minute'), comment=" n°"),
    Field('f_tooldamage_critical_weighted', type='float', default = 0,
          label=T('Critical Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_vibrations_blisk', type='float', default = 0,
          label=T('Vibrations per BLISK'), comment=" n°"),
    Field('f_vibrations_blisk_noreaction', type='float', default = 0,
          label=T('Vibrations per BLISK with 5G without reaction'), comment=" n°"),
    Field('f_feedspeedadoption_number', type='float', default = 0,
          label=T('Times of Feed Speed Adoption'), comment=" n°"),
    Field('f_additionaltime_vibration', type='float', default = 5,
          label=T('Additional Processing Time through Feed Speed Adoption per Vibration'), comment=" s"),
    Field('f_additionaltime_total', type='float', default = 0,
          label=T('Additional Processing Time through Feed Speed Adoption'), comment=" s"),
    Field('f_damage_blisk', type='float', default = 0,
          label=T('Damage per BLISK'), comment=" "),
    format='%(f_millingtype)s',
    migrate=settings.migrate)

############################################
#Table for Hub Finishing
db.define_table('t_blisktasks_hubfinish',
    Field('f_surface_thickness', type='float', default = 0.017,
          label=T('Surface Thickness'), comment="mm"),
    Field('f_millingvolume', type='float', default = 0,
          label=T('Milling Volume per BLISK'), comment="mm^3"),
    Field('f_radialcuttingdepth', type='float', default = 1,
          label=T('Radial Cutting Depth'), comment="mm"),
    Field('f_axialcuttingdepth', type='float', default = 0.6,
          label=T('Axial Cutting Depth'), comment="mm"),
    Field('f_feedspeed_nofiveG', type='float', default = 450,
          label=T('Feed Speed - Without 5G'), comment="mm/min"),
    Field('f_feedspeed_fiveG', type='float', default = 460,
          label=T('Feed Speed - With 5G - Expected'), comment="mm/min"),
    Field('f_mrr_nofiveG', type='float',
          label=T('MRR - Without 5G'), comment="mm^3/min"),
    Field('f_mrr_fiveG', type='float',
          label=T('MRR - With 5G'), comment="mm^3/min"),
    Field('f_millingtime', type='float',
          label=T('Milling Time'), comment="min"),
    Field('f_vibrations_shattering', type='float', default = 0.1,
          label=T('Vibrations per Minute causing shattering marks'), comment=" n°"),
    Field('f_vibrations_nonreparable', type='float', default = 0,
          label=T('Vibrations per Minute causing non reparable BLISK damage'), comment=" n°"),
    Field('f_tooldamage', type='float', default = 0.00001,
          label=T('Tool Damages per Minute'), comment=" n°"),
    Field('f_tooldamage_weighted', type='float', default = 0,
          label=T('Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_tooldamage_critical', type='float', default = 0.00001,
          label=T('Critical Tool Damages per Minute'), comment=" n°"),
    Field('f_tooldamage_critical_weighted', type='float', default = 0,
          label=T('Critical Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_vibrations_blisk', type='float', default = 0,
          label=T('Vibrations per BLISK'), comment=" n°"),
    Field('f_vibrations_blisk_noreaction', type='float', default = 0,
          label=T('Vibrations per BLISK with 5G without reaction'), comment=" n°"),
    Field('f_feedspeedadoption_number', type='float', default = 0,
          label=T('Times of Feed Speed Adoption'), comment=" n°"),
    Field('f_additionaltime_vibration', type='float', default = 1,
          label=T('Additional Processing Time through Feed Speed Adoption per Vibration'), comment=" s"),
    Field('f_additionaltime_total', type='float', default = 0,
          label=T('Additional Processing Time through Feed Speed Adoption'), comment=" s"),
    Field('f_damage_blisk', type='float', default = 0,
          label=T('Damage per BLISK'), comment=" "),
    format='%(f_millingtype)s',
    migrate=settings.migrate)

############################################
db.define_table('t_blisktasks_accumulated',
    Field('f_millingtime', type='float',
          label=T('Milling Time'), comment="min"),
    Field('f_tooldamage_weighted', type='float', default = 0,
          label=T('Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_tooldamage_critical_weighted', type='float', default = 0,
          label=T('Critical Tool Damages per Minute - weighted'), comment=" n°"),
    Field('f_vibrations_blisk', type='float', default = 0,
          label=T('Vibrations per BLISK'), comment=" n°"),
    Field('f_vibrations_blisk_noreaction', type='float', default = 0,
          label=T('Vibrations per BLISK with 5G without reaction'), comment=" n°"),
    Field('f_feedspeedadoption_number', type='float', default = 0,
          label=T('Times of Feed Speed Adoption'), comment="  n°"),
    Field('f_additionaltime_total', type='float', default = 0,
          label=T('Additional Processing Time through Feed Speed Adoption'), comment=" s"),
    Field('f_damage_blisk', type='float', default = 0,
          label=T('Damage per BLISK'), comment=" "),
    migrate=settings.migrate)

############################################
